/* - test-PG for learning/testing Jan00 -
 * urspruengliches Programm enthaelt arrays die dynamisch allociert
 * und ueber pointer referenziert werden
 * das neue Programm ersetzt (mcplx *) durch (A_cplx)
 * als c-version wie gehabt aber unter c++ als array class (array_m)
 * mit Uebergabe als Pointer und Arrayzugriff auf cplx[]
 * mit virtual speicher-management (langsamer!!!), blocking etc.
 * zentrale Klasse an die alle konstruktoren gemeldet werden und ueber die
 *  msg gesendet werden kann oder einfacher: instanz enthaelt von Anfang an
 *  array-pointer oder Datei-pointer
 * Jun00
 *  funktioniert nicht, da zeiger auf dbl rueckgeliefert wird
 *  dieser im PG irgendwann verwendet werden
 *  - elemente sollten selber Klasse sein, die bis Abschluss der Zuweisung existiert
 *    und sich mit der Vektorklasse abstimmt
 *  - oder Nutzung von Macros APut, AGet
 *
 * c     v[4]    mcplx *v => a_cplx v 
 * c++   v[4]          class a_cplx v
 *
 *  Das neue Programm enthaelt Definitionen fuer die grossen Vektoren
 *  und deren Teilung in Bloecke bzw. deren Speicherung auf Disk
 */
#ifndef _ARRAY_M_H
#define _ARRAY_M_H
#include <stdlib.h>
#include <stdio.h>
/* #include <assert.h>  warnings on irix-CC */
#include "block.h"

typedef struct ttvec {	/* store large vectors in blocks */
  mcplx *v[B_NUM];	/* blocks of vector, NULL: on disk */
  int id;		/* file ID if not enough memory */
} tvec;

#ifdef __cplusplus
/* virtueller Speicher macht Programm wesentlich langsamer! */
#define CONFIG_A_CPLX		/* define/undef */
#endif

#if 1
#undef CONFIG_A_CPLX	/* abgeschaltet, da es nicht funktioniert! */
#endif

/* typedef int mcplx; */

#if defined(CONFIG_A_CPLX)
#define assert(xxx) { if(!(xxx)){ printf(__FILE__" L%d assertion failed\n",__LINE__);exit(1);} }
/* #define DEBUG 1 */
/* #define NDEBUG 1 */
/* ------------------ class.h ---------------------------------------- */
class a_cplx {
public:
  /* Konstruktoren */
  /*  a_cplx(); */
  a_cplx(mcplx *a=NULL,unsigned long len=0l);
  a_cplx(a_cplx &);	// copy-constructor (functions-argumente)
  // Destruktor
  ~a_cplx();		// evl. Referenzen zaehlen und
			// Speicher bei Ref=0 freigeben?
  mcplx & operator[](unsigned long);	// aa[4]=7; Elementzugriff
  a_cplx& operator=(a_cplx&);		// aa=ab;
  a_cplx& operator=(mcplx *);		// aa=b;
  unsigned long querylen(){ return length; }	// cout << a.querylen();
  void setlen(unsigned long,unsigned);
  int ifnull();
  void flush();
  mcplx *thearray;		// pointer to memory (or NULL)

private:
#define A_blen	(1<<8)		// must be a 2^n value (n>1)
#define A_mask  (A_blen-1)	// must be 0..0011..1
#define A_nidx  (~(unsigned long)0l)	// invalid index
  unsigned long length;		// len of array
  // emulation of array if thearray==0
  mcplx buf[A_blen];		// enthaelt Element
  mcplx bufold[A_blen];		// und old value of Element
  unsigned long idx[A_blen];	//  .. mit diesem index
  unsigned filenum;
  FILE *f1;			// file shared, therefor pointer! :) 
};

// ------------------ class.c ----------------------------------------
inline void a_cplx::flush(){
   int i;
   // local copy (function-argument) makes datum invalid, store buf!
   if(!thearray){    /* write old buf if changed ??? */
#if defined(DEBUG)
     printf(" flush a%d",filenum);
#endif
     for(i=0;i<A_blen;i++){
       if( bufold[i]!=buf[i] && idx[i]!=A_nidx){ /* Mai00 */
#if defined(DEBUG)
         printf("\n write a%d[%lu]=buf[%d]=%6.3f",filenum,idx[i],i,D(buf[i]));
#endif
         assert(!fseek(f1,long(idx[i]*sizeof(mcplx)),SEEK_SET));
         assert(1==fwrite(buf+i,sizeof(mcplx),1,f1));
         bufold[i]=buf[i];
       }
       // idx[i]=A_nidx;	/* flag buf invalid, necessary??? */
     }
   }
}

inline a_cplx::a_cplx(a_cplx &a){		// copy-constructor!!!
  int i;
  // a.flush();
  length=a.length;filenum=a.filenum;f1=a.f1;
  for(i=0;i<A_blen;i++){
    bufold[i]=a.bufold[i];buf[i]=a.buf[i];
    idx[i]=a.idx[i];a.idx[i]=A_nidx; }
  thearray=a.thearray;
#if defined(DEBUG)
  printf(" copy-constructor=%p(%p)",this,&a);
#endif
}

inline a_cplx::a_cplx(mcplx *a,unsigned long len){ int i; // constructor!
  length=len; filenum=0; f1=NULL; thearray=a;
  for(i=0;i<A_blen;i++){ bufold[i]=7;buf[i]=0;idx[i]=A_nidx; }
#if defined(DEBUG)
  printf(" constructor(mcplx *,ulong)=%p\n",this);
#endif
}

inline a_cplx::~a_cplx(){
  // local copy (function-argument) makes datum invalid, store buf!
  flush();
#if defined(DEBUG)
  printf(" destructor %p\n",this);
#endif
}

inline void  a_cplx::setlen(unsigned long l,unsigned fnum){
   char s1[20];
#if defined(DEBUG)
   printf(" %p.setlen(%lu,%u)\n",this,l,fnum);
#endif
   length=l; filenum=fnum;
   if(!thearray)if(!f1){		// virtual memory as file
     sprintf(s1,"a_cplx%d.tmp",filenum);
#if defined(DEBUG)
    printf(" create %s\n",s1);
#endif
     f1=fopen(s1,"r+");if(!f1)f1=fopen(s1,"w+");
     assert(f1);
   }
}

inline int  a_cplx::ifnull(){ return ((length==0)?1:0); }

/* if no mem use buf[idx & A_mask] !? */
inline mcplx & a_cplx::operator[](unsigned long i){
   int j,jj;
#if !defined(NDEBUG)
   if(i>=length) { printf("\nArrayOVL i=%lu l=%lu\n",i,length);
     assert(i<length); }	// !assert && !defined(NDEBUG) => ERROR
#endif
   if(thearray){ return thearray[i];  }		/* reference! */
   else {
     j=i & A_mask;
#if defined(DEBUG)
     printf("\n a%d[%lu]=buf[%d]=%f",filenum,idx[j],j,D(buf[j]));
#endif
     // printf(" not enough memory for vector\n");
     // printf(" does not work! because op[] gives pointer, causes asynchronus errors\n");
     // exit(1);
     if(i!=idx[j]){
       /* write old buf if changed */
       if(bufold[j]!=buf[j] && idx[j]!=A_nidx) flush();
       {
         assert(!fseek(f1,long(i*sizeof(mcplx)),SEEK_SET));
         buf[j]=0;jj=fread(buf+j,sizeof(mcplx),1,f1);
#if defined(DEBUG)
         printf(" read=%d",jj);
#endif
       }
       bufold[j]=buf[j]; idx[j]=i;
     }
#if defined(DEBUG)
     printf(" a%d[%lu]=buf[%d]=%f",filenum,i,j,D(buf[j]));
#endif
     return buf[j];		/* reference! */
   }
}

inline a_cplx& a_cplx::operator=(a_cplx& x){	// aa=ab;
#if defined(DEBUG)
  printf(" copy a%d %p to %p\n",filenum,&x,this);
#endif
   int i;
   // local copy (function-argument) makes datum invalid, store buf!
   // x.flush();
   length=x.length; filenum=x.filenum; thearray=x.thearray; f1=x.f1;
   for(i=0;i<A_blen;i++){
     buf[i]=x.buf[i]; bufold[i]=x.bufold[i];
     idx[i]=x.idx[i]; x.idx[i]=A_nidx; // x is now invalid
   }
   return *this;
}

inline a_cplx& a_cplx::operator=(mcplx *x){	// aa=b;
#if defined(DEBUG)
   printf(" %p.thearray=%p",this,thearray);
#endif
   thearray=x; return *this;
}
// --------------------- end-of-class --------------------------------

// use the following definition for declarations of arrays
#define A_cplx    a_cplx 
#define A_def(x)  class a_cplx x	// also as array x[4] possible
#define A_defa(x,n)  class a_cplx x[n]	// also as array x[4] possible
#define A_set_len(x,len,fnum)  x.setlen(len,fnum)
#define A_free(x)	myfree((void **) &(x.thearray))
#define A_ptr(x)	x.thearray
#define A_ifnull(x)     x.ifnull()
#else /* --- no C++, only c: A_cplx a,b; --- */
#if 0
#define A_cplx    tvec * 
#define A_def(x)  tvec *x=NULL 			/* 18Jan00 */
#define A_defa(x,n)  tvec *x[n] 		/* 20Jan00 */
#define A_set_len(x,len,fnum)			/* do nothing */
#define A_free(x)	myfree((void **) &x)
#endif
#define A_ptr(x)	x
#define A_ifnull(x)	((x==NULL)?1:0)
#endif 

/* this funktion is provisorium, replace it by using faster method */
/* get element i of vector v */
static inline mcplx vec_e(tvec *v, ULong i){
  int blk=b_getnum(i); return v->v[blk][i-b_ofs[blk]];
}
static inline mcplx *vec_pe(tvec *v, ULong i){
  int blk=b_getnum(i); return &(v->v[blk][i-b_ofs[blk]]);
}

#if 0		/* try this as a_test.c */
int func1(A_cplx a){		/* pointer to object */
  printf("func1-test: a[3]=%d\n",a[3]);	/* korrekt ??? */
  a[3]*=2; return 0; }

int main(){
  mcplx a[5],b[8]; int i;
  A_def(pa);A_def(pb);
  pa=NULL;pb=b;A_set_len(pa,5,1);A_set_len(pb,8,2);
  printf(" sizeof(A_cplx)=%d\n",sizeof(A_cplx));
  for(i=0;i<5;i++)pa[i]=i*3;
  for(i=0;i<8;i++)pb[i]=i*2;
  func1(pa);func1(pa);
  printf( "test %d\n", pa[3]);
  printf( "test %d\n", pb[3]);
  printf( " pa=%p pb=%p &pa=%p &pb=%p\n",&(pa[0]),&(pb[0]),&pa,&pb);
  pb[8]=0; }
#endif
#endif
