/* (c) Joerg Schulenburg Jun 2000

 this is part of spin-package

 it is for division of matrix multiplication 
 in parallelizable block matrix multiplication
 
    b = H * a    (a,b vectors, H matrix)
    
    b[i] = sum_j H[i,j] * a[j]
    
 blocks can be multiplicated step by step on one system or
 they can be multiplicated on different processors/systems
 
 but you have to pay additional network/harddisk traffic
 
 if b_num is one you have only one block (similar to old version)


 */
#include "block.h"

unsigned long b_ofs[B_NUM];	/* start index 0..n1-1 of block */
unsigned long b_len[B_NUM];	/* block len */
unsigned long b_hnz[B_NUM];	/* block NonZero H-entries */
unsigned long b_snz[B_NUM];	/* stored block entries */
unsigned long b_sn1[B_NUM];	/* stored block lines */
struct thxy b_hbuf[B_NUM];      /* buffer for faster r/w-access */ 
int         b_hbl[B_NUM];       /* num valid data in buffer hbuf */  
      
/* initialization, n1 is whole matrix size */
int b_ini(unsigned long n1,int vvv){
  int i;
  unsigned long l,l1,l2;
  l=(n1+B_NUM-1)/B_NUM;               /* block-length */
#if defined(HAVE_MMAP) && defined(CFG_PAGESIZE)
  /* mmap offset must be a multiple of PAGESIZE! */
  if (l>0) l=((l-1)/CFG_PAGESIZE+1)*CFG_PAGESIZE;
#endif /* CFG_PAGESIZE */
  for (l1=n1,i=0;i<B_NUM;i++) {
    if ( l1>=l ) l2=l; else l2=l1;
    if ( i==0  ) b_ofs[i]=0; else b_ofs[i]=b_ofs[i-1]+b_len[i-1];
    b_len[i]=l2;
    b_sn1[i]=0;
    b_hnz[i]=0;   
    b_snz[i]=0;   
    b_hbl[i]=0;
    l1-=l2;
  }
  if (vvv) {
    printf(" block_length= %lu (mod %lu)\n", l, l1%l);
    if (vvv>1)
    for (i=0;i<B_NUM;i++)
     printf(" block %2d from %8lu len %8lu\n",i,b_ofs[i],b_len[i]);
  }
  return 0;
}
