/*
 *  - l1[] is a compact memory array for base configurations
 *  - configs are stored in a bytewise form
 *  - access it via getl1() and putl1()
 */

#include "config.h"	/* define tbase,tbase1 (define later here!) */
#include "spinsdef.h"	/* define tbase,tbase1 (define later here!) */
#ifndef _TBASE_H
#define _TBASE_H 1

#include <stdio.h>
#include "spins.h"	/* define tbase,tbase1 (later in hilbert.h?) */

#if S_char != 1
#  error "hmm..., S_char != 1 byte"
#endif
extern unsigned char *l1;	/* tbase *l1 - until Jan00 */
#define Bsize  ((CM(1,2,2)*NN-1)/8+1)    /* minimum char[] space */

#define FILE_l1 "tmp/tmp_l1.dat"
extern FILE *fl1; 		/* nur fuer mmap, spaeter verstecken! */

int save_l1(unsigned char *l1, ULong n1, ULong ofs);
int load_l1(unsigned char *l1, ULong n1);

/* tbase getl1(ULong i); */
void putl1(ULong i, tbase kfg, unsigned char *l1);

static inline tbase getl1(ULong i){	/* use b=next(b) for b=getl1(i++) if possible */
#if 0 && defined(LHsystem) 		/* low-high byteorder, much faster */
/* DEC-wildfire: unaligned access (signal=meldung=slow-down), aber ergebnis korrekt */
   return (*(tbase *)(l1+i*Bsize))
   & ~((~(tbase)0)<<(8*(Bsize-1))<<8); /* (64bit)1l<<64 nicht spezifiziert! */
#else
#if NN > 32  &&  NN <= 40 && Bsize == 5
   /* M-JJ N=33..40 Bsize=sizeof() */
   return ((tbase)l1[i*Bsize  ]) 
        | ((tbase)l1[i*Bsize+1])<<8 
        | ((tbase)l1[i*Bsize+2])<<16
        | ((tbase)l1[i*Bsize+3])<<24
        | ((tbase)l1[i*Bsize+4])<<32;
#else
   tbase t1; unsigned int j; /* slow but save */
   for(t1=0l,j=0;j<Bsize;j++) t1|=((tbase)l1[i*Bsize+j])<<(8*j);
   return t1;
#endif
#endif
}

#endif
